#define PIN_PUSHBUTTON 12
#define PIN_LED	13

#define DEBOUNCEDELAY 500

int iState_prev = LOW;
unsigned long ulMillis_prev = 0;
bool bLedState = false;

void setup()
{ 
	pinMode(PIN_PUSHBUTTON, INPUT);
	pinMode(PIN_LED, OUTPUT);
}

void loop()
{
	int iState = digitalRead(PIN_PUSHBUTTON);
	
	if( LOW == iState_prev
	 && HIGH == iState )
	{	// OFF→ON時
		unsigned long ulMillis = millis();

		if( DEBOUNCEDELAY < (ulMillis - ulMillis_prev) )
		{	// デバウンス時間よりも経過しているならば、正当な「OFF→ON」とみなす
			onPress();
		}

		ulMillis_prev = ulMillis;
	}

	iState_prev = iState;
}

void onPress()
{
	bLedState = !bLedState;
	digitalWrite(PIN_LED, bLedState ? HIGH : LOW );
}
